package db.conn.impl;

import javax.sql.DataSource;
import java.util.Properties;
import db.conn.AbstractDataSourceConnectorFactory;
import db.util.Instantiator;

public class NamedDataSourceConnectorFactory extends AbstractDataSourceConnectorFactory {
	
	private String mName=null;
	private DataSource mDS=null;
	
	public void initializeValues(Properties pProp) {
		if(pProp!=null){
			mName=pProp.getProperty("nameds");			
		}
	}
	
	public void destroy() {
		mDS=null;
		mName=null;		
	}
	
	public DataSource getDataSource() {
		if(mDS==null) mDS=(DataSource)Instantiator.getInstance().getNamedObject(mName,DataSource.class);
		return mDS;
	}
	
	public String toString() {		
		if(mName!=null)
			return getClass()+": {nameds="+mName+"}";
		return getClass()+": No Properties";
	}
}