package org.bits.ec.dbcon;

import java.sql.Connection;
import java.sql.SQLException;
import db.cw.ConnectionWrapper;

/**
 * DB Connectivity Manager.
 */
public class DBManager {
	/**
	 * Tells us if the database connectivity works or not.
	 */
	public boolean isConnected() {
		Connection mCon = null;
		try {
			mCon = getConnection();
			if (mCon == null)
				return false;
			mCon.close();
			mCon = null;
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return true;
	}

	/**
	 * Returns a new JDBC Connection.
	 */
	public Connection getConnection() {
		return ConnectionWrapper.getConnection();
	}

	/**
	 * Closes JDBC Connection.
	 */
	public void closeConnection(Connection pCon) {
		ConnectionWrapper.closeConnection(pCon);
		pCon = null;
	}
}