package org.bits.ec.entity;

import org.bits.ec.dbcon.DBQuery;

/**
 * Candidate Model.
 */
public class CandidateModel {

	/**
	 * Allowed Status for Candidate
	 */
	private int isAllowed(int pCandidateID) {
		int mFlag = 0;
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pCandidateID),
				"candidateid", "allow", "candidate_table");
		if (mObj == null || !(mObj instanceof String))
			return mFlag;
		if ("Y".equals((String) mObj))
			mFlag = 1;
		return mFlag;
	}

	/**
	 * Validates Candidate
	 */
	public int validateCandidate(int pCandidateID) { // int mFlag=new
		if (isAllowed(pCandidateID) <= 0 || getRoleIDForID(pCandidateID) <= 0)
			return 0;
		return 1;
	}

	/**
	 * Role ID for Candidate ID
	 */
	public int getRoleIDForID(int pCandidateID) {
		int mRoleID = -1;
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pCandidateID),
				"candidateid", "roleid", "candidate_table");
		if (mObj == null || !(mObj instanceof Integer))
			return mRoleID;
		mRoleID = ((Integer) mObj).intValue();
		if (new RoleModel().validateRole(mRoleID) <= 0)
			mRoleID = -1;
		return mRoleID;
	}

	/**
	 * Candidate Name for Candidate ID
	 */
	public String getNameForID(int pCandidateID) {
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pCandidateID),
				"candidateid", "candidatename", "candidate_table");
		if (mObj == null || !(mObj instanceof String))
			return "";
		return (String) mObj;
	}

	/**
	 * Role Allowed Status for Candidate
	 */
	public int isAllowedForRole(int pCandidateID, int pRoleID) {
		int mFlag = 0;
		if (isAllowed(pCandidateID) <= 0)
			return mFlag;
		if (pRoleID != getRoleIDForID(pCandidateID))
			return mFlag;
		mFlag = 1;
		return mFlag;
	}

}