package org.bits.ec.protsys;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import org.bits.ec.dbcon.DBConvert;
import org.bits.ec.dbcon.DBManager;
import org.bits.ec.dbcon.DBQuery;

/**
 * Generic Authentication Module which uses the database.
 */
public class Auth {

	/**
	 * Validates Plain Password
	 */
	public int validatePlainPassword(String pUser, String pPassword,
			String pSrcUserColumn, String pSrcPasswordColumn, String pTable) {
		int mFlag = 0;
		int mCount = 0;
		Connection mCon = null;
		Statement mStmt = null;
		ResultSet mRs = null;
		String mCmdStr = null;
		DBConvert mDC = new DBConvert();
		DBManager mDBM = new DBManager();

		mCon = mDBM.getConnection();
		if (mCon == null)
			return mFlag;

		if (pUser == null || "".equals(pUser))
			return mFlag;
		if (pPassword == null || "".equals(pPassword))
			return mFlag;
		if (pSrcUserColumn == null || "".equals(pSrcUserColumn))
			return mFlag;
		if (pSrcPasswordColumn == null || "".equals(pSrcPasswordColumn))
			return mFlag;
		if (pTable == null || "".equals(pTable))
			return mFlag;

		mCmdStr = "select count(*) from " + pTable + " where " + pSrcUserColumn
				+ "=\'" + mDC.doDBConvert(pUser) + "\' and "
				+ pSrcPasswordColumn + "= password(\'"
				+ mDC.doDBConvert(pPassword) + "\')";

		try {
			mStmt = mCon.createStatement();
			mRs = mStmt.executeQuery(mCmdStr);
			while (mRs.next()) {
				try {
					mCount = (int) mRs.getFloat(1);
				} catch (Exception eE) {
					eE.printStackTrace();
					mCount = 0;
				}
			}
		} catch (SQLException eSQLE) {
			eSQLE.printStackTrace();
			mCount = 0;
		}

		// Clean Up
		if (mRs != null) {
			try {
				mRs.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mRs = null;

		if (mStmt != null) {
			try {
				mStmt.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mStmt = null;

		mDBM.closeConnection(mCon);
		mCon = null;

		if (mCount == 1)
			mFlag = 1;
		return mFlag;
	}

	/**
	 * Validates Encrypted Password
	 */
	public int validateEncryptedPassword(String pUser, String pSessionKey,
			String pEncryptedPassword, String pSrcUserColumn,
			String pSrcPasswordColumn, String pTable) {
		int mFlag = 0;
		Object mObj = null;
		if (pSessionKey == null || "".equals(pSessionKey))
			return mFlag;
		if (pEncryptedPassword == null || "".equals(pEncryptedPassword))
			return mFlag;
		mObj = new DBQuery().fetchKeyEntity(pUser, pSrcUserColumn,
				pSrcPasswordColumn, pTable);
		if (mObj == null || !(mObj instanceof String))
			return mFlag;
		if (pEncryptedPassword.equals(new TextHash().oneWayHash(pUser,
				pSessionKey, (String) mObj)))
			mFlag = 1;
		return mFlag;
	}

	/**
	 * Makes Encrypted Password
	 */
	public String generateEncryptedPassword(String pUser, String pSessionKey,
			String pPassword, String pSrcUserColumn, String pSrcPasswordColumn,
			String pTable) {
		String mEncryptedPassword = "";
		Object mObj = new DBQuery().fetchKeyEntity(pUser, pSrcUserColumn,
				pSrcPasswordColumn, pTable);
		if (mObj == null || !(mObj instanceof String))
			return mEncryptedPassword;
		mEncryptedPassword = new TextHash().oneWayHash(pUser, pSessionKey,
				(String) mObj);
		return mEncryptedPassword;
	}

}