package org.bits.ec.web;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import org.bits.ec.dbcon.DBConvert;
import org.bits.ec.dbcon.DBManager;
import org.bits.ec.entity.PlaceModel;
import org.bits.ec.entity.RoleModel;
import org.bits.ec.entity.UserModel;
import org.bits.ec.entity.VoteModel;

/**
 * Web Module.
 */
public class WebModule {

	/**
	 * Get Candidates for a Role ID.
	 */
	private List getCandidatesFor(int pRoleID) {
		Connection mCon = null;
		Statement mStmt = null;
		ResultSet mRs = null;
		String mCmdStr = null;
		int mCandidateID = -1;
		String mCandidateName = null;
		// RoleModel mRM=new RoleModel();
		HashMap mMap = null;
		ArrayList mList = null;
		DBManager mDBM = new DBManager();

		// if(mRM.validateRole(pRoleID)<=0) return mList;

		mCon = mDBM.getConnection();
		if (mCon == null)
			return mList;

		// Faster than other queries, not entirely good though.
		mCmdStr = "select candidateid, candidatename from candidate_table where allow='Y' and roleid="
				+ pRoleID;

		mList = new ArrayList();

		try {
			mStmt = mCon.createStatement();
			mRs = mStmt.executeQuery(mCmdStr);
			while (mRs.next()) {
				try {
					mCandidateID = (int) mRs.getFloat(1);
					mCandidateName = mRs.getString(2);

					// Add it here.
					mMap = new HashMap();
					mMap.put("candidate", new Integer(mCandidateID));
					mMap.put("candidatename", mCandidateName);
					mList.add(mMap);
					mMap = null;

				} catch (Exception eE) {
					eE.printStackTrace();
					mCandidateID = -1;
					mCandidateName = null;
				}
			}
		} catch (SQLException eSQLE) {
			eSQLE.printStackTrace();
			mList.clear();
			mList = null;
		}

		// Clean Up
		if (mRs != null) {
			try {
				mRs.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mRs = null;

		if (mStmt != null) {
			try {
				mStmt.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mStmt = null;

		mDBM.closeConnection(mCon);
		mCon = null;

		return mList;
	}

	/**
	 * Get Roles to Vote for.
	 */
	public List getVotingInformation(String pUserName) {
		Connection mCon = null;
		Statement mStmt = null;
		ResultSet mRs = null;
		String mCmdStr = null;
		int mRoleID = -1;
		String mPlaceName = null;
		UserModel mUM = new UserModel();
		VoteModel mVM = new VoteModel();
		PlaceModel mPM = new PlaceModel();
		RoleModel mRM = new RoleModel();

		HashMap mMap = null;
		ArrayList mList = null;
		DBManager mDBM = new DBManager();

		if (mUM.validateUser(pUserName) <= 0)
			return mList;

		mCon = mDBM.getConnection();
		if (mCon == null)
			return mList;

		mCmdStr = "select uat.roleid from user_allowed_table uat, user_table ut where ut.username=\'"
				+ new DBConvert().doDBConvert(pUserName)
				+ "\' and ut.userid=uat.userid";

		mList = new ArrayList();

		try {
			mStmt = mCon.createStatement();
			mRs = mStmt.executeQuery(mCmdStr);
			while (mRs.next()) {
				try {
					mRoleID = (int) mRs.getFloat(1);
				} catch (Exception eE) {
					eE.printStackTrace();
					mRoleID = -1;
				}
				if (mRM.validateRole(mRoleID) <= 0)
					;
				else {
					mMap = new HashMap();
					mMap.put("role", new Integer(mRoleID));
					mMap.put("rolename", mRM.getNameForID(mRoleID));
					mPlaceName = mPM.getNameForID(mRM.getPlaceIDForID(mRoleID));
					if ("".equals(mPlaceName) || "-".equals(mPlaceName)
							|| "None".equalsIgnoreCase(mPlaceName)) ;
					else
						mMap.put("placename", mPlaceName);
					if (mVM.hasVotedForRoleID(pUserName, mRoleID) <= 0) {
						mMap.put("voted", new Boolean(false));
						//May not get GC-ed soon..
						mMap.put("candidatelist", getCandidatesFor(mRoleID));
					} else
						mMap.put("voted", new Boolean(true));
					mList.add(mMap);
					mMap = null;
				}
			}
		} catch (SQLException eSQLE) {
			eSQLE.printStackTrace();
			mList.clear();
			mList = null;
		}

		// Clean Up
		if (mRs != null) {
			try {
				mRs.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mRs = null;

		if (mStmt != null) {
			try {
				mStmt.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mStmt = null;

		mDBM.closeConnection(mCon);
		mCon = null;

		return mList;
	}

}